aboutsummaryrefslogtreecommitdiffstats
path: root/package/base-files
diff options
context:
space:
mode:
authorJo-Philipp Wich <jow@openwrt.org>2010-01-13 18:39:44 +0000
committerJo-Philipp Wich <jow@openwrt.org>2010-01-13 18:39:44 +0000
commitcb30b52ec19e0ce3fda2920448c2676d6b905113 (patch)
treebef387af8a0adc40b61bdb6299825eef29a60da5 /package/base-files
parent5f84b8a838c6f0d178af4d7fa4b124f757f5b3f8 (diff)
downloadupstream-cb30b52ec19e0ce3fda2920448c2676d6b905113.tar.gz
upstream-cb30b52ec19e0ce3fda2920448c2676d6b905113.tar.bz2
upstream-cb30b52ec19e0ce3fda2920448c2676d6b905113.zip
base-files, mac80211 (#6491) - fix wep key handling in iw with mac80211 based drivers - sanitize keys where necessary - put a procedure prepare_key_wep() into /sbin/wifi for use by other driver backends
SVN-Revision: 19118
Diffstat (limited to 'package/base-files')
-rwxr-xr-xpackage/base-files/files/sbin/wifi13
1 files changed, 13 insertions, 0 deletions
diff --git a/package/base-files/files/sbin/wifi b/package/base-files/files/sbin/wifi
index 90aeef725d..5b6007f0a9 100755
--- a/package/base-files/files/sbin/wifi
+++ b/package/base-files/files/sbin/wifi
@@ -34,6 +34,19 @@ bridge_interface() {(
[ "$iftype" = bridge ] && config_get "$cfg" ifname
)}
+prepare_key_wep() {
+ local key="$1"
+ local hex=1
+
+ echo -n "$key" | grep -qE "[^a-fA-F0-9]" && hex=0
+ [ "${#key}" -eq 10 -a $hex -eq 1 ] || \
+ [ "${#key}" -eq 26 -a $hex -eq 1 ] || {
+ [ "${key:0:2}" = "s:" ] && key="${key#s:}"
+ key="$(echo -n "$key" | hexdump -ve '1/1 "%02x" ""')"
+ }
+ echo "$key"
+}
+
wifi_fixup_hwmode() {
local device="$1"
local default="$2"